unit Main;

interface

uses
  SysUtils, Windows, Messages, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Classes, ExtCtrls, MsgSock;

type
  TFormMain = class(TForm)
    LabelI: TLabel;
    MessageSocket: TMessageSocket;
    LabelCnt: TLabel;
    procedure MessageSocketSentMessage(Sender: TObject; const MessageID: Word;
      const SourceHandle: Integer; const DataPtr: Pointer;
      const DataSize: Word);
    procedure MessageSocketPostedMessage(Sender: TObject;
      const MessageID: Word; const SourceHandle: Integer;
      const DataPtr: Pointer; const DataSize: Word);
  private
  	Cnt: Integer;
  end;

var
  FormMain: TFormMain;

implementation

{$R *.DFM}

{
Message Socket Property Values
	HighMessageID = 110
  LowMessageID = 100
  	Two TMessageSocket component ignore each other if their LowMessageIDs are different.
    Moreover, only MessageID between LowMessageID + 1 and HighMessageID can be used.
  PostSupport = true
    This component must handle Posted Messages, so PostSupport is to be set to True.
  PostThreadPriority = tpHigher
    No higher priority thread are present, so tpHigher is enough.
}

{This event is fired to signal a sincronous sent message from application APP0.
 During its execution APP0 is blocked inside the SendMessage method.           }

procedure TFormMain.MessageSocketSentMessage(Sender: TObject;
  const MessageID: Word; const SourceHandle: Integer; const DataPtr: Pointer;
  const DataSize: Word);

var
  S: String[128];
	J,K: Longint;

begin

	case MessageID of
    101: begin
    	SetLength(S,DataSize);
      move(DataPtr^, S[1], DataSize);
      Cnt := 0;
      LabelI.Caption := S;
      LabelCnt.Caption := IntToStr(Cnt);
      {If this code is uncommented APP0 blocks for many seconds}
      {K := 0;
      for J := 0 to 100000000 do
      	K := K + 1; }
    end;
    103: begin
    	{MessageHandled call unblock APP0. You must use it, otherwise Application.Terminate could cause a
       complete lock of APP0. Alternatively you could request the APP1 termination using a posted message}
    	MessageSocket.MessageHandled;
		  Application.Terminate;
    end;
  end;

end;

{This event is fired to signal a asincronous post message from application APP0.
 During its execution APP0 is not blocked inside the PostMessage method.        }

procedure TFormMain.MessageSocketPostedMessage(Sender: TObject;
  const MessageID: Word; const SourceHandle: Integer; const DataPtr: Pointer;
  const DataSize: Word);

var
  S: String[128];
	J,K: Longint;

begin

	case MessageID of
    102: begin
    	SetLength(S,DataSize);
      move(DataPtr^, S[1], DataSize);
      Inc(Cnt);
      LabelI.Caption := S;
      LabelCnt.Caption := IntToStr(Cnt);
      {If this code is uncommented APP0 doesn't block}
      {K := 0;
      for J := 0 to 100000000 do
      	K := K + 1; }
    end;
  end;

end;


end.

